---
date: 2019-04-04T15:59:52+02:00
title: DIGESTS.txt
weight: 15
---

Le fichier `DIGESTS.txt` se trouve dans le répertoire `files/` ou `hints/` d'un
défi. Il contient les condensats des fichiers se trouvant dans le dossier
respectif.

Il génére avec la commande :

```sh
b2sum * > DIGESTS.txt
```

{{% notice warning %}}
Ce fichier est à générer **avant** l'upload. Son utilité est d'avoir un moyen
de vérifier, une fois sur place, sans connexion Internet, que l'intégralité de
l'arborescence n'a pas été altérée et que les fichiers servis sont bien les
mêmes que sur vos dépôts Git.
{{% /notice %}}

La commande `b2sum` fait parti des *GNU Core Utilities* depuis la [version
8.26](https://github.com/coreutils/coreutils/commit/ea94589e9ef02624a3837f97f80efd7d3dcf56bf).

L'algorithme [blake2b](https://blake2.net/) est utilisé à la place d'un SHA-1
ou MD5 car il est plus rapide que ces derniers et est encore considéré comme
sûr.


## Cas des fichiers en plusieurs parties

Dans le cas où vous êtes contraint de découper vos fichiers avant de les
uploader, seule la somme de contrôle du fichier entier, avant découpage, est
nécessaire.


## Exemple

```
3222734c6c8782682a9c36135a3518e8f4d1facabf76e702cf50da0037a4ed0a425e51266c2914fb83828573e397f96c2a95d419bd85919055479d028f51dba5  fic2016.jpg
023939b0c52b0dfce66954318ab82f7a8c10af4c79c8d5781612b58c74f3ace056067d7b15967e612b176a186b46d3d900c4db8881ba47202521eec33e5bb87b  fic.org
7c91450239cf9b0717642c55c3429dd7326db26e87d4ca198758053333f0640ee89d2dd9b2f1919598f89644b06aa8fc2085648e3d1e542a6db324c9b16a0bdf  header.tex
```
